/*--------------------------------------------------------------------------------------------------------------*/
// THESE ARE THE MAP INFORMATIONS:
/*--------------------------------------------------------------------------------------------------------------*/
// KANSAS WAR BY PAPADAN:
// OCTOBER 2006
// FROM TEXAS BY ENSEMBLE:
// OCTOBER 2003:
/*--------------------------------------------------------------------------------------------------------------*/
// ******************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*--------------------------------------------------------------------------------------------------------------*/
include "mercenaries.xs";
void main(void)
{
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*==============================================================================================================*/
// ************************************** CHOOSES THE NATIVES TRIBES: ***************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
        int subCiv3=-1;
/*--------------------------------------------------------------------------------------------------------------*/   
        if (rmAllocateSubCivs(12) == true)
/*--------------------------------------------------------------------------------------------------------------*/		
   {
/*--------------------------------------------------------------------------------------------------------------*/   
		subCiv0=rmGetCivID("Comanche");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Comanche");

		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois"); 

		subCiv2=rmGetCivID("Aztecs");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Aztecs");

		subCiv3=rmGetCivID("Maya");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Maya");
/*--------------------------------------------------------------------------------------------------------------*/		
   }
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*==============================================================================================================*/
// ****************************************** DEFINE THE MAP SIZE: ******************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
	// PICKS THE MAP SIZE:
	// int playerTiles=10000;
	   int playerTiles=25000;
		
	// if (cNumberNonGaiaPlayers >4) // REMOVED BY ENSEMBLE:
	//	playerTiles = 9500;  // REMOVED BY ENSEMBLE:

	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
/*--------------------------------------------------------------------------------------------------------------*/
// **************************************** PICKS THE MAP PARAMETERS: ***************************************** //
/*--------------------------------------------------------------------------------------------------------------*/	
	// SET MAP ELEVATION PARAMETERS:
	// rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	rmSetMapElevationHeightBlend(1);
	
	// PICKS A DEFAULT WATER HEIGHT:
	rmSetSeaLevel(4.0);
	
	// SET THE LIGHTING:
	rmSetLightingSet("Texas");

    // PICKS THE DEFAULT WATER:
	rmSetSeaType("Amazon River");
	
	// PICKS THE DEFAULT TERRAIN:
	rmSetBaseTerrainMix("texas_grass");
	
	// PICKS THE TERRAIN INITIALISATION:
	rmTerrainInitialize("texas\ground1_tex", 5.0);
	
	// SET THE MAP TYPE:
	rmSetMapType("texas");
	rmSetMapType("grass");
	rmSetMapType("land");

	// CHOOSES THE MERCS:
	chooseMercs();

	// CORNER CONSTRAINT:
	rmSetWorldCircleConstraint(true);
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*==============================================================================================================*/
// *********************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS:************************** //
/*--------------------------------------------------------------------------------------------------------------*/
    int classPlayer=rmDefineClass("player");
    rmDefineClass("startingUnit");
    rmDefineClass("classForest");
	rmDefineClass("natives");
	rmDefineClass("importantItem");
	rmDefineClass("socketClass");
	rmDefineClass("nuggets");
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*==============================================================================================================*/
// **************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// *********************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*--------------------------------------------------------------------------------------------------------------*/
      // MAP EDGE CONSTRAINTS:
      int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  //DAL - was 24
	
      // CARDINAL DIRECTIONS:
      int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
      int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
      int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
      int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

      // PLAYER CONSTRAINTS:
      int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 20.0);
      int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 45.0);
      int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);
      int avoidTC=rmCreateTypeDistanceConstraint("stay away from TC", "TownCenter", 20.0);
      int avoidTP=rmCreateTypeDistanceConstraint("stay away from Trading Post Sockets", "SocketTradeRoute", 14.0);  
  
      // AVOID SEAFOOD: 	
      int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
      
	  // NATURE AVOIDANCE:
	  int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	  int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
	  int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
	
      // UNIT AVOIDANCE:
      int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
      int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
      int avoidStartingUnitsLarge=rmCreateClassDistanceConstraint("objects avoid starting units large", rmClassID("startingUnit"), 50.0);
      int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
      int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
      int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 50.0);
      int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 25.0);
      int avoidCow=rmCreateTypeDistanceConstraint("cow avoids cow", "cow", 10.0);
	  int avoidElk=rmCreateTypeDistanceConstraint("elk avoids elk", "Elk", 35.0);
	
      // DECORATION AVOIDANCE:
      int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
	
      // COIN AVOIDANCE:
      int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "Mine", 10.0);
      int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 20.0);	
	
      // AVOID IMPASSABLE LAND:
      int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
  	
  	  // TRADE ROUTE AVOIDANCE:
	  int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	  int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
	 	
	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*==============================================================================================================*/
// ************************************ PLACE THE 2 TEAMS ON THE MAP: ***************************************** //
/*--------------------------------------------------------------------------------------------------------------*/ 
        if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.15, 0.35);
		   
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.13, 0.37);
		}
		rmPlacePlayersCircular(0.35, 0.35, 0.0);

		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.65, 0.85);
		
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.63, 0.87);
		}
		rmPlacePlayersCircular(0.35, 0.35, 0.0);
	} 
	else
	{
  		 rmSetPlacementSection(0.0, 0.95);
		  
		rmPlacePlayersCircular(0.35, 0.35, 0.0);
	}
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*==============================================================================================================*/
// ******************************** DEFINE THE SET UP FOR THE PLAYER AREAS: *********************************** //
/*--------------------------------------------------------------------------------------------------------------*/
        float playerFraction=rmAreaTilesToFraction(100);
/*--------------------------------------------------------------------------------------------------------------*/   
        for(i=1; <cNumberPlayers)
/*--------------------------------------------------------------------------------------------------------------*/   
   {
/*--------------------------------------------------------------------------------------------------------------*/   
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
        
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// SET THE AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
        
		// SET THE CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET THE AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET THE AREA TERRAIN TYPE:
		rmSetAreaTerrainType(id, "texas\ground2");
        rmSetAreaWarnFailure(id, false);
/*--------------------------------------------------------------------------------------------------------------*/	  
   }
/*--------------------------------------------------------------------------------------------------------------*/   
        // BUILD THE AREAS:
        rmBuildAllAreas();
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*==============================================================================================================*/
// ****************************** GENERAL INFORMATIONS ON PLACEMENT ORDER: ************************************ //
/*==============================================================================================================*/
    // Placement order
	// Trade Route -> Players and player stuff -> Natives -> Secrets -> Cliffs -> Nuggets
	// Place other objects that were defined earlier
/*==============================================================================================================*/
// *********************************** DEFINE AND PLACE THE TRADE ROUTE: ************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
	  int tradeRouteID = rmCreateTradeRoute(); 

      rmAddTradeRouteWaypoint(tradeRouteID, 0.1, 0.90);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.6);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.56, 0.56);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.6, 0.35);
      rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.1);

      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route");
/*--------------------------------------------------------------------------------------------------------------*/
// *************************************** DEFINE THE TRADE SOCKETS: ****************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
      int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	  rmSetObjectDefAllowOverlap(socketID, true);
      // rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
	     rmAddObjectDefToClass(socketID, rmClassID("socketClass")); // REPLACED BY ME:
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 8.0);	
/*--------------------------------------------------------------------------------------------------------------*/	
// ********************************* ADD THE SOCKETS ALONG THE TRADE ROUTE: *********************************** //
/*--------------------------------------------------------------------------------------------------------------*/
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.1); // SOCKET 1:
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5); // SOCKET 2:
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.9); // SOCKET 3:
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*==============================================================================================================*/
// ********************************* DEFINE THE PLAYERS AND THE RESOURCES: ************************************ //
/*--------------------------------------------------------------------------------------------------------------*/
	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
      rmSetObjectDefMinDistance(startingUnits, 5.0);
      rmSetObjectDefMaxDistance(startingUnits, 10.0);
	  //rmAddObjectDefConstraint(startingUnits, avoidAll);

	  int startingTCID= rmCreateObjectDef("startingTC");
	  if ( rmGetNomadStart())
	{
	  rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	  else
	{
	  rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	  
	  // GIVE IT A LITTLE WIGGLE ROOM FOR MAPS WITH GREATER THAN FOUR PLAYERS:
	  
	  if ( cNumberNonGaiaPlayers > 4 )
	  {
		rmSetObjectDefMinDistance(startingTCID, 0.0);
		rmSetObjectDefMaxDistance(startingTCID, 6.0);
	  }
	}
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*==============================================================================================================*/
// ************************************ DEFINE THE STARTING BERRYBUSH: **************************************** //
/*--------------------------------------------------------------------------------------------------------------*/ 
       int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	   rmAddObjectDefItem(StartBerryBushID, "BerryBush", 2, 4.0);
	   rmSetObjectDefMinDistance(StartBerryBushID, 12.0);
	   rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
	   rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);	
/*--------------------------------------------------------------------------------------------------------------*/
// *************************************** DEFINE THE STARTING TREES: ***************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeTexasDirt", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 8);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 14);
	    //rmAddObjectDefConstraint(StartAreaTreeID, avoidStartResource);
	    //rmAddObjectDefConstraint(StartAreaTreeID, shortAvoidImpassableLand);
	    //rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	    //rmAddObjectDefConstraint(StartAreaTreeID, avoidNatives);	
/*--------------------------------------------------------------------------------------------------------------*/
// *************************************** DEFINE THE PLAYER BISONS: ****************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
        int playerBisonID=rmCreateObjectDef("player bison herd");
        rmAddObjectDefItem(playerBisonID, "bison", rmRandInt(6,8), 6.0);
        // rmSetObjectDefMinDistance(playerBisonID, 40.0);
        // rmSetObjectDefMaxDistance(playerBisonID, 45.0);
		   rmSetObjectDefMinDistance(playerBisonID, 20.0);
           rmSetObjectDefMaxDistance(playerBisonID, 30.0);
	    //rmAddObjectDefConstraint(playerBisonID, avoidTradeRoute);
	    //rmAddObjectDefConstraint(playerBisonID, avoidImportantItem);
	    rmSetObjectDefCreateHerd(playerBisonID, true);
/*--------------------------------------------------------------------------------------------------------------*/
        // DEFINE THE STARTING SILVER MINES:
		int startSilverID = rmCreateObjectDef("player silver 1");
	    rmAddObjectDefItem(startSilverID, "mine", 1, 5.0);
	    //rmAddObjectDefConstraint(startSilverID, avoidTradeRoute);
	    //rmAddObjectDefConstraint(startSilverID, greatLakesConstraint);
	    rmSetObjectDefMinDistance(startSilverID, 10.0);
	    rmSetObjectDefMaxDistance(startSilverID, 16.0);
		rmAddObjectDefConstraint(startSilverID, coinAvoidCoin);
	    //rmAddObjectDefConstraint(startSilverID, avoidImportantItem);
	    //rmAddObjectDefConstraint(startSilverID, avoidRandomBerries);
	    //rmAddObjectDefConstraint(startSilverID, avoidImpassableLand);
/*--------------------------------------------------------------------------------------------------------------*/
        // DEFINE THE PLAYER NUGGET:
	    int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 12.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 18.0);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidTradeRouteCliff);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    rmAddObjectDefConstraint(playerNuggetID, avoidTC);
	    //rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    // rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*==============================================================================================================*/
// ********************************** PLACE THE PLAYERS AND THE RESOURCES: ************************************ //
/*--------------------------------------------------------------------------------------------------------------*/
	    for(i=1; <cNumberPlayers)
/*--------------------------------------------------------------------------------------------------------------*/	
	{
/*--------------------------------------------------------------------------------------------------------------*/	
		// PLACE THE STARTING UNITS AND A TC:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		
		// PLACE THE BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER BISONS:
		rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		//rmPlaceObjectDefAtLoc(playerBisonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING SILVER MINES:
		rmPlaceObjectDefAtLoc(startSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		//rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*--------------------------------------------------------------------------------------------------------------*/		
	}
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*==============================================================================================================*/
// ************************************* DEFINE AND PLACE SOME PONDS: ***************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 8.0);
/*--------------------------------------------------------------------------------------------------------------*/		
        int smallPondID=rmCreateArea("small pond 1");
/*--------------------------------------------------------------------------------------------------------------*/		
		int numPonds=1;
/*--------------------------------------------------------------------------------------------------------------*/		
	    for(i=0; <numPonds)
/*--------------------------------------------------------------------------------------------------------------*/		
	{
/*--------------------------------------------------------------------------------------------------------------*/	
		// rmSetAreaSize(smallPondID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(700));
		   rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1250), rmAreaTilesToFraction(1250));
		rmSetAreaWaterType(smallPondID, "texas pond");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.5);
		rmSetAreaSmoothDistance(smallPondID, 5);
		rmAddAreaConstraint(smallPondID, playerConstraint);
		rmAddAreaConstraint(smallPondID, avoidNatives);
		//rmAddAreaConstraint(smallPondID, avoidImportantItem);
		rmSetAreaWarnFailure(smallPondID, false);
		// rmSetAreaLocation(smallPondID, 0.5, 0.5); 
		rmSetAreaLocation(smallPondID, 0.45, 0.75); 
		rmBuildArea(smallPondID);
	}
/*--------------------------------------------------------------------------------------------------------------*/
// ************************************ DEFINE AND PLACE SMALL POND 2: **************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
	    int smallPond2ID=rmCreateArea("small pond 2");
/*--------------------------------------------------------------------------------------------------------------*/
        for(i=0; <numPonds)
/*--------------------------------------------------------------------------------------------------------------*/		
	{
/*--------------------------------------------------------------------------------------------------------------*/	
		// rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(700));
		   rmSetAreaSize(smallPond2ID, rmAreaTilesToFraction(1250), rmAreaTilesToFraction(1250));
		rmSetAreaWaterType(smallPond2ID, "texas pond");
		rmSetAreaBaseHeight(smallPond2ID, 4);
		rmAddAreaToClass(smallPond2ID, pondClass);
		rmSetAreaCoherence(smallPond2ID, 0.5);
		rmSetAreaSmoothDistance(smallPond2ID, 5);
		rmAddAreaConstraint(smallPond2ID, playerConstraint);
		rmAddAreaConstraint(smallPond2ID, avoidNatives);
		//rmAddAreaConstraint(smallPond2ID, avoidImportantItem);
		rmSetAreaWarnFailure(smallPond2ID, false);
		// rmSetAreaLocation(smallPond2ID, 0.5, 0.5); 
		   rmSetAreaLocation(smallPond2ID, 0.75, 0.45); 
		rmBuildArea(smallPond2ID);
/*--------------------------------------------------------------------------------------------------------------*/		
	}
/*--------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE AND PLACE SMALL POND 3: *************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
	    int smallPond3ID=rmCreateArea("small pond 3");
/*--------------------------------------------------------------------------------------------------------------*/		
		for(i=0; <numPonds)
/*--------------------------------------------------------------------------------------------------------------*/	    
	{
/*--------------------------------------------------------------------------------------------------------------*/	
		// rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(700));
		   rmSetAreaSize(smallPond3ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
		rmSetAreaWaterType(smallPond3ID, "texas pond");
		rmSetAreaBaseHeight(smallPond3ID, 4);
		rmAddAreaToClass(smallPond3ID, pondClass);
		rmSetAreaCoherence(smallPond3ID, 0.5);
		rmSetAreaSmoothDistance(smallPond3ID, 5);
		rmAddAreaConstraint(smallPond3ID, playerConstraint);
		rmAddAreaConstraint(smallPond3ID, avoidNatives);
		//rmAddAreaConstraint(smallPond3ID, avoidImportantItem);
		rmSetAreaWarnFailure(smallPond3ID, false);
		// rmSetAreaLocation(smallPond3ID, 0.5, 0.5); 
		   rmSetAreaLocation(smallPond3ID, 0.3, 0.5); 
		rmBuildArea(smallPond3ID);
/*--------------------------------------------------------------------------------------------------------------*/		
	}
/*--------------------------------------------------------------------------------------------------------------*/
// ********************************** DEFINE AND PLACE THE SMALL POND 4: ************************************** //
/*--------------------------------------------------------------------------------------------------------------*/  
        int smallPond4ID=rmCreateArea("small pond 4");
/*--------------------------------------------------------------------------------------------------------------*/		
	    for(i=0; <numPonds)
/*--------------------------------------------------------------------------------------------------------------*/	    
	{
/*--------------------------------------------------------------------------------------------------------------*/	
		// rmSetAreaSize(smallPond4ID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(700));
		   rmSetAreaSize(smallPond4ID, rmAreaTilesToFraction(650), rmAreaTilesToFraction(650));
		rmSetAreaWaterType(smallPond4ID, "texas pond");
		rmSetAreaBaseHeight(smallPond4ID, 4);
		rmAddAreaToClass(smallPond4ID, pondClass);
		rmSetAreaCoherence(smallPond4ID, 0.5);
		rmSetAreaSmoothDistance(smallPond4ID, 5);
		rmAddAreaConstraint(smallPond4ID, playerConstraint);
		rmAddAreaConstraint(smallPond4ID, avoidNatives);
		//rmAddAreaConstraint(smallPond4ID, avoidImportantItem);
		rmSetAreaWarnFailure(smallPond4ID, false);
		// rmSetAreaLocation(smallPond4ID, 0.5, 0.5); 
		   rmSetAreaLocation(smallPond4ID, 0.5, 0.3); 
		rmBuildArea(smallPond4ID);
/*--------------------------------------------------------------------------------------------------------------*/		
	}	
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*==============================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*--------------------------------------------------------------------------------------------------------------*/
        if (subCiv0 == rmGetCivID("Comanche"))
	{  
		int comancheVillageID = -1;
		comancheVillageID = rmCreateGrouping("comanche village", "native comanche village 1");
		//rmSetGroupingMinDistance(comancheVillageID, 0.0);
		//rmSetGroupingMaxDistance(comancheVillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMinDistance(comancheVillageID, 0.0);
		rmSetGroupingMaxDistance(comancheVillageID, 0.0);
		rmAddGroupingConstraint(comancheVillageID, avoidImpassableLand);
		rmAddGroupingToClass(comancheVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(comancheVillageID, avoidNatives);
		//rmAddGroupingConstraint(comancheVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(comancheVillageID, 0, 0.5, 0.9);
	} 

	    if (subCiv1 == rmGetCivID("iroquois"))
	{  
		int iroquoisVillageID = -1;
		// iroquoisVillageID = rmCreateGrouping("iroquois village", "native iroquois village 1");
		   iroquoisVillageID = rmCreateGrouping("iroquois village", "native comanche village 1");
		//rmSetGroupingMinDistance(iroquoisVillageID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMinDistance(iroquoisVillageID, 0.0);
		rmSetGroupingMaxDistance(iroquoisVillageID, 0.0);
		rmAddGroupingConstraint(iroquoisVillageID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillageID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(iroquoisVillageID, 0, 0.9, 0.5);
	} 

	    if (subCiv2 == rmGetCivID("aztecs"))
	{  
		int aztecsVillageID = -1;
		// aztecsVillageID = rmCreateGrouping("aztecs village", "native aztec village 1");
		   aztecsVillageID = rmCreateGrouping("aztecs village", "native comanche village 1");
		//rmSetGroupingMinDistance(aztecsVillageID, 0.0);
		//rmSetGroupingMaxDistance(aztecsVillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMinDistance(aztecsVillageID, 0.0);
		rmSetGroupingMaxDistance(aztecsVillageID, 0.0);
		rmAddGroupingConstraint(aztecsVillageID, avoidImpassableLand);
		rmAddGroupingToClass(aztecsVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(aztecsVillageID, avoidNatives);
		//rmAddGroupingConstraint(aztecsVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(aztecsVillageID, 0, 0.1, 0.5);
	}

	    if (subCiv3 == rmGetCivID("maya"))
	{  
		int mayaVillageID = -1;
		// mayaVillageID = rmCreateGrouping("maya village", "native maya village 1");
		   mayaVillageID = rmCreateGrouping("maya village", "native comanche village 1");
		//rmSetGroupingMinDistance(mayaVillageID, 0.0);
		//rmSetGroupingMaxDistance(mayaVillageID, rmXFractionToMeters(0.5));
		rmSetGroupingMinDistance(mayaVillageID, 0.0);
		rmSetGroupingMaxDistance(mayaVillageID, 0.0);
		rmAddGroupingConstraint(mayaVillageID, avoidImpassableLand);
		rmAddGroupingToClass(mayaVillageID, rmClassID("natives"));
		rmAddGroupingConstraint(mayaVillageID, avoidNatives);
		//rmAddGroupingConstraint(mayaVillageID, insideCircleConstraint);
		rmPlaceGroupingAtLoc(mayaVillageID, 0, 0.5, 0.1);
	}
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*==============================================================================================================*/
// ********************************** DEFINE AND PLACE THE FISHSALMON: **************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
/*--------------------------------------------------------------------------------------------------------------*/   
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*==============================================================================================================*/
// ******************************** DEFINE AND PLACE SILVER MINES NUMBER 1: *********************************** //
/*--------------------------------------------------------------------------------------------------------------*/
	int goldID = rmCreateObjectDef("random gold 1");
	rmAddObjectDefItem(goldID, "mine", 1, 0);
	rmSetObjectDefMinDistance(goldID, 0.0);
	// rmSetObjectDefMaxDistance(goldID, rmXFractionToMeters(0.5));
	   rmSetObjectDefMaxDistance(goldID, 0.0);
	//rmAddObjectDefConstraint(goldID, avoidSocket);
	//rmAddObjectDefConstraint(goldID, avoidTC);
	//rmAddObjectDefConstraint(goldID, pondConstraint);
	//rmAddObjectDefConstraint(goldID, avoidAll);
	rmAddObjectDefConstraint(goldID, avoidCoin);
	//rmAddObjectDefConstraint(goldID, avoidLongCoin);
    //rmAddObjectDefConstraint(goldID, Eastward);
	//rmAddObjectDefConstraint(goldID, avoidStartingUnits);
/*--------------------------------------------------------------------------------------------------------------*/	
	// rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
       rmPlaceObjectDefAtLoc(goldID, 0, 0.15, 0.65);	
/*--------------------------------------------------------------------------------------------------------------*/
// ******************************* DEFINE AND PLACE THE SILVER MINE NUMBER 2: ********************************* //
/*--------------------------------------------------------------------------------------------------------------*/
	int gold2ID = rmCreateObjectDef("random gold 2");
	rmAddObjectDefItem(gold2ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(gold2ID, 0.0);
	// rmSetObjectDefMaxDistance(gold2ID, rmXFractionToMeters(0.5));
	   rmSetObjectDefMaxDistance(gold2ID, 0.0);
	//rmAddObjectDefConstraint(gold2ID, avoidSocket);
	//rmAddObjectDefConstraint(gold2ID, avoidTC);
	//rmAddObjectDefConstraint(gold2ID, pondConstraint);
	//rmAddObjectDefConstraint(gold2ID, avoidAll);
	rmAddObjectDefConstraint(gold2ID, avoidCoin);
	//rmAddObjectDefConstraint(gold2ID, avoidLongCoin);
    //rmAddObjectDefConstraint(gold2ID, Eastward);
	//rmAddObjectDefConstraint(gold2ID, avoidStartingUnits);
/*--------------------------------------------------------------------------------------------------------------*/	
	// rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
       rmPlaceObjectDefAtLoc(gold2ID, 0, 0.65, 0.15);
/*--------------------------------------------------------------------------------------------------------------*/
// ***************************** DEFINE AND PLACE THE SILVER MINE NUMBER 3: *********************************** //
/*--------------------------------------------------------------------------------------------------------------*/
	int gold3ID = rmCreateObjectDef("random gold 3");
	rmAddObjectDefItem(gold3ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(gold3ID, 0.0);
	// rmSetObjectDefMaxDistance(gold3ID, rmXFractionToMeters(0.5));
	   rmSetObjectDefMaxDistance(gold3ID, 0.0);
	//rmAddObjectDefConstraint(gold3ID, avoidSocket);
	//rmAddObjectDefConstraint(gold3ID, avoidTC);
	//rmAddObjectDefConstraint(gold3ID, pondConstraint);
	//rmAddObjectDefConstraint(gold3ID, avoidAll);
	rmAddObjectDefConstraint(gold3ID, avoidCoin);
	//rmAddObjectDefConstraint(gold3ID, avoidLongCoin);
    //rmAddObjectDefConstraint(gold3ID, Eastward);
	//rmAddObjectDefConstraint(gold3ID, avoidStartingUnits);
/*--------------------------------------------------------------------------------------------------------------*/	
	// rmPlaceObjectDefAtLoc(gold3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
       rmPlaceObjectDefAtLoc(gold3ID, 0, 0.35, 0.85);
/*--------------------------------------------------------------------------------------------------------------*/
// ******************************** DEFINE AND PLACE THE SILVER MINE NUMBER 4: ******************************** //
/*--------------------------------------------------------------------------------------------------------------*/
	int gold4ID = rmCreateObjectDef("random gold 4");
	rmAddObjectDefItem(gold4ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(gold4ID, 0.0);
	// rmSetObjectDefMaxDistance(gold4ID, rmXFractionToMeters(0.5));
	   rmSetObjectDefMaxDistance(gold4ID, 0.0);
	//rmAddObjectDefConstraint(gold4ID, avoidSocket);
	//rmAddObjectDefConstraint(gold4ID, avoidTC);
	//rmAddObjectDefConstraint(gold4ID, pondConstraint);
	//rmAddObjectDefConstraint(gold4ID, avoidAll);
	rmAddObjectDefConstraint(gold4ID, avoidCoin);
	//rmAddObjectDefConstraint(gold4ID, avoidLongCoin);
    //rmAddObjectDefConstraint(gold4ID, Eastward);
	//rmAddObjectDefConstraint(gold4ID, avoidStartingUnits);
/*--------------------------------------------------------------------------------------------------------------*/	
	// rmPlaceObjectDefAtLoc(gold4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
       rmPlaceObjectDefAtLoc(gold4ID, 0, 0.85, 0.35);
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*==============================================================================================================*/
// ************************************* DEFINE AND PLACE THE COW 1: ****************************************** //
/*--------------------------------------------------------------------------------------------------------------*/    
	int cowID=rmCreateObjectDef("cow 1");
    rmAddObjectDefItem(cowID, "cow", rmRandInt(7,11), 4.0);
    rmSetObjectDefMinDistance(cowID, 0.0);
    // rmSetObjectDefMaxDistance(cowID, rmXFractionToMeters(0.5));
	   rmSetObjectDefMaxDistance(cowID, 0.0);
    rmAddObjectDefConstraint(cowID, avoidCow);
	rmAddObjectDefConstraint(cowID, avoidAll);
	//rmAddObjectDefConstraint(cowID, playerConstraint);
	//rmAddObjectDefConstraint(cowID, forestConstraint);
    rmAddObjectDefConstraint(cowID, avoidImpassableLand);
/*--------------------------------------------------------------------------------------------------------------*/	
	rmPlaceObjectDefAtLoc(cowID, 0, 0.6, 0.2);
/*--------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE AND PLACE THE COW 2: ****************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
    int cow2ID=rmCreateObjectDef("cow 2");
    rmAddObjectDefItem(cow2ID, "cow", rmRandInt(7,11), 4.0);
    rmSetObjectDefMinDistance(cow2ID, 0.0);
    // rmSetObjectDefMaxDistance(cow2ID, rmXFractionToMeters(0.5));
	   rmSetObjectDefMaxDistance(cow2ID, 0.0);
    rmAddObjectDefConstraint(cow2ID, avoidCow);
	rmAddObjectDefConstraint(cow2ID, avoidAll);
	//rmAddObjectDefConstraint(cow2ID, playerConstraint);
	//rmAddObjectDefConstraint(cow2ID, forestConstraint);
    rmAddObjectDefConstraint(cow2ID, avoidImpassableLand);
/*--------------------------------------------------------------------------------------------------------------*/	
	rmPlaceObjectDefAtLoc(cow2ID, 0, 0.2, 0.6);	
/*--------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE AND PLACE THE COW 3: ****************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
    int cow3ID=rmCreateObjectDef("cow 3");
    rmAddObjectDefItem(cow3ID, "cow", rmRandInt(7,11), 4.0);
    rmSetObjectDefMinDistance(cow3ID, 0.0);
    // rmSetObjectDefMaxDistance(cow3ID, rmXFractionToMeters(0.5));
	   rmSetObjectDefMaxDistance(cow3ID, 0.0);
    rmAddObjectDefConstraint(cow3ID, avoidCow);
	rmAddObjectDefConstraint(cow3ID, avoidAll);
	//rmAddObjectDefConstraint(cow3ID, playerConstraint);
	//rmAddObjectDefConstraint(cow3ID, forestConstraint);
    rmAddObjectDefConstraint(cow3ID, avoidImpassableLand);
/*--------------------------------------------------------------------------------------------------------------*/	
	rmPlaceObjectDefAtLoc(cow3ID, 0, 0.4, 0.9);	
/*--------------------------------------------------------------------------------------------------------------*/
// ************************************* DEFINE AND PLACE THE COW 4: ****************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
    int cow4ID=rmCreateObjectDef("cow 4");
    rmAddObjectDefItem(cow4ID, "cow", rmRandInt(7,11), 4.0);
    rmSetObjectDefMinDistance(cow4ID, 0.0);
    // rmSetObjectDefMaxDistance(cow4ID, rmXFractionToMeters(0.5));
	   rmSetObjectDefMaxDistance(cow4ID, 0.0);
    rmAddObjectDefConstraint(cow4ID, avoidCow);
	rmAddObjectDefConstraint(cow4ID, avoidAll);
	//rmAddObjectDefConstraint(cow4ID, playerConstraint);
	//rmAddObjectDefConstraint(cow4ID, forestConstraint);
    rmAddObjectDefConstraint(cow4ID, avoidImpassableLand);
/*--------------------------------------------------------------------------------------------------------------*/	
	rmPlaceObjectDefAtLoc(cow4ID, 0, 0.9, 0.4);	
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*==============================================================================================================*/
// ************************************** DEFINE AND PLACE THE ELKS: ****************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
    int elkID=rmCreateObjectDef("elk herd");
	rmAddObjectDefItem(elkID, "elk", rmRandInt(3,5), 6.0);
    rmSetObjectDefMinDistance(elkID, 0.0);
    rmSetObjectDefMaxDistance(elkID, rmXFractionToMeters(0.5));
    rmAddObjectDefConstraint(elkID, avoidElk);
	rmAddObjectDefConstraint(elkID, avoidCoin);
    //rmAddObjectDefConstraint(elkID, avoidMoose);
	rmAddObjectDefConstraint(elkID, avoidAll);
	rmAddObjectDefConstraint(elkID, avoidTC);
    rmAddObjectDefConstraint(elkID, avoidImpassableLand);
	rmAddObjectDefConstraint(elkID, avoidSocket);
	//rmAddObjectDefConstraint(elkID, avoidTradeRoute);
	rmAddObjectDefConstraint(elkID, avoidStartingUnits);
/*--------------------------------------------------------------------------------------------------------------*/
    rmSetObjectDefCreateHerd(elkID, true);
	rmPlaceObjectDefAtLoc(elkID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*9);	
/*--------------------------------------------------------------------------------------------------------------*/	
// ************************************** DEFINE AND PLACE THE NUGGETS: *************************************** // 
/*--------------------------------------------------------------------------------------------------------------*/
    int nuggetID= rmCreateObjectDef("nugget"); 
	rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	rmSetObjectDefMinDistance(nuggetID, 0.0);
	rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
  	rmAddObjectDefConstraint(nuggetID, avoidNugget);
  	rmAddObjectDefConstraint(nuggetID, avoidAll);
  	rmAddObjectDefConstraint(nuggetID, avoidStartingUnits);
	rmAddObjectDefConstraint(nuggetID, avoidSocket);
	rmAddObjectDefConstraint(nuggetID, avoidTC);
	rmAddObjectDefConstraint(nuggetID, pondConstraint);
	//rmAddObjectDefConstraint(nuggetID, avoidTP);
	rmAddObjectDefConstraint(nuggetID, avoidNatives);
	//rmAddObjectDefConstraint(nuggetID, avoidLakes);
	//rmAddObjectDefConstraint(nuggetID, circleConstraint);
/*--------------------------------------------------------------------------------------------------------------*/	
	rmSetNuggetDifficulty(1, 3);
	rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*==============================================================================================================*/
// ********************************** VARIABLES REQUIRED BY THE FORESTS: ************************************** //
/*--------------------------------------------------------------------------------------------------------------*/  
	        // TEXT:
	        int numTries = -1;
	        int failCount = -1;
/*==============================================================================================================*/	
// *************************** DEFINE AND PLACE THE FORESTS: - NORTH AND SOUTH: ******************************* //
/*==============================================================================================================*/
// ********************************** DEFINE AND PLACE THE SOUTH FOREST: ************************************** //
/*--------------------------------------------------------------------------------------------------------------*/			
			int forestTreeID = 0;
/*--------------------------------------------------------------------------------------------------------------*/			
	        // numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 below
	           numTries=8*cNumberNonGaiaPlayers;
/*--------------------------------------------------------------------------------------------------------------*/			   
			failCount=0;
/*--------------------------------------------------------------------------------------------------------------*/			
	        for (i=0; <numTries)
/*--------------------------------------------------------------------------------------------------------------*/			
		{ 
/*--------------------------------------------------------------------------------------------------------------*/		
			int westForest=rmCreateArea("westForest"+i);
			rmSetAreaWarnFailure(westForest, false);
			// rmSetAreaSize(westForest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			   rmSetAreaSize(westForest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			rmSetAreaForestType(westForest, "texas forest dirt");
			rmSetAreaForestDensity(westForest, 0.7);
			rmSetAreaForestClumpiness(westForest, 0.4);
			rmSetAreaForestUnderbrush(westForest, 0.0);
			rmSetAreaMinBlobs(westForest, 1);
			rmSetAreaMaxBlobs(westForest, 3);
			rmSetAreaMinBlobDistance(westForest, 5.0);
			rmSetAreaMaxBlobDistance(westForest, 20.0);
			rmSetAreaCoherence(westForest, 0.4);
			rmSetAreaSmoothDistance(westForest, 10);
			//rmAddAreaConstraint(westForest, avoidImportantItem);		   // DAL added, to try and make sure natives got on the map w/o override.
			rmAddAreaConstraint(westForest, avoidCoin);
			rmAddAreaConstraint(westForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(westForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			rmAddAreaConstraint(westForest, pondConstraint);						// DAL adeed, to keep these forests in the west.
			rmAddAreaConstraint(westForest, Southward);
			rmAddAreaConstraint(westForest, avoidNatives);
			rmAddAreaConstraint(westForest, avoidSocket);
			rmAddAreaConstraint(westForest, avoidCow);
/*--------------------------------------------------------------------------------------------------------------*/			
			if(rmBuildArea(westForest)==false)
			{
				// Stop trying once we fail 5 times in a row.  
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0; 
		}
/*--------------------------------------------------------------------------------------------------------------*/
// ********************************** DEFINE AND PLACE THE NORTH FOREST: ************************************** //
/*--------------------------------------------------------------------------------------------------------------*/			
			// numTries=5*cNumberNonGaiaPlayers;  // DAL - 5 here, 5 above.
	           numTries=8*cNumberNonGaiaPlayers;
/*--------------------------------------------------------------------------------------------------------------*/			   
			failCount=0;
/*--------------------------------------------------------------------------------------------------------------*/
	        for (i=0; <numTries)
/*--------------------------------------------------------------------------------------------------------------*/
		{  
/*--------------------------------------------------------------------------------------------------------------*/		
			int eastForest=rmCreateArea("eastForest"+i);
			rmSetAreaWarnFailure(eastForest, false);
			// rmSetAreaSize(eastForest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			   rmSetAreaSize(eastForest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
			rmSetAreaForestType(eastForest, "texas forest");
			rmSetAreaForestDensity(eastForest, 0.7);
			rmSetAreaForestClumpiness(eastForest, 0.4);
			rmSetAreaForestUnderbrush(eastForest, 0.0);
			rmSetAreaMinBlobs(eastForest, 1);
			rmSetAreaMaxBlobs(eastForest, 3);
			rmSetAreaMinBlobDistance(eastForest, 5.0);
			rmSetAreaMaxBlobDistance(eastForest, 20.0);
			rmSetAreaCoherence(eastForest, 0.4);
			rmSetAreaSmoothDistance(eastForest, 10);
			//rmAddAreaConstraint(eastForest, avoidImportantItem);			// DAL added, to try and make sure natives got on the map w/o override.
			rmAddAreaConstraint(eastForest, avoidCoin);
			rmAddAreaConstraint(eastForest, playerConstraintForest);		// DAL adeed, to keep forests away from the player.
			rmAddAreaConstraint(eastForest, forestConstraint);				// DAL adeed, to keep forests away from each other.
			rmAddAreaConstraint(eastForest, pondConstraint);						// DAL adeed, to keep these forests in the east.
			rmAddAreaConstraint(eastForest, Northward);	
			rmAddAreaConstraint(eastForest, avoidNatives);
			rmAddAreaConstraint(eastForest, avoidSocket);
			rmAddAreaConstraint(eastForest, avoidCow);
/*--------------------------------------------------------------------------------------------------------------*/			
			if(rmBuildArea(eastForest)==false)
			{
				// Stop trying once we fail 5 times in a row.
				failCount++;
				if(failCount==5)
					break;
			}
			else
				failCount=0;
/*--------------------------------------------------------------------------------------------------------------*/				
		}
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*==============================================================================================================*/
// ************************************ DEFINE AND PLACE THE RANDOM TREES: ************************************ //
/*--------------------------------------------------------------------------------------------------------------*/
	int randomTreeID=rmCreateObjectDef("random tree");
	// rmAddObjectDefItem(randomTreeID, "TreeNewEngland", 1, 0.0);
	   rmAddObjectDefItem(randomTreeID, "TreeTexasDirt", 1, 0.0);
	rmSetObjectDefMinDistance(randomTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(randomTreeID, avoidTC);
	//rmAddObjectDefConstraint(randomTreeID, avoidLakes);
	rmAddObjectDefConstraint(randomTreeID, avoidTP);
	rmAddObjectDefConstraint(randomTreeID, avoidCow);
	rmAddObjectDefConstraint(randomTreeID, avoidAll); 
	rmAddObjectDefConstraint(randomTreeID, forestObjConstraint); 
	rmAddObjectDefConstraint(randomTreeID, avoidNatives);
/*--------------------------------------------------------------------------------------------------------------*/	
	rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);		
/*==============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*==============================================================================================================*/
// ************************************* THIS IS THE END OF THE MAP: ****************************************** //
/*--------------------------------------------------------------------------------------------------------------*/
}  
/*--------------------------------------------------------------------------------------------------------------*/		
